
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Audit_logDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_log = await db.audit_log.create(
            {
                id: data.id || undefined,
        
        action: data.action
        ||
        null
            ,
            
        entity: data.entity
        ||
        null
            ,
            
        entity_ref: data.entity_ref
        ||
        null
            ,
            
        action_time: data.action_time
        ||
        null
            ,
            
        details: data.details
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await audit_log.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return audit_log;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const audit_logData = data.map((item, index) => ({
                id: item.id || undefined,
                
                action: item.action
            ||
            null
            ,
            
                entity: item.entity
            ||
            null
            ,
            
                entity_ref: item.entity_ref
            ||
            null
            ,
            
                action_time: item.action_time
            ||
            null
            ,
            
                details: item.details
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const audit_log = await db.audit_log.bulkCreate(audit_logData, { transaction });

        // For each item created, replace relation files
        

        return audit_log;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const audit_log = await db.audit_log.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.action !== undefined) updatePayload.action = data.action;
        
        
        if (data.entity !== undefined) updatePayload.entity = data.entity;
        
        
        if (data.entity_ref !== undefined) updatePayload.entity_ref = data.entity_ref;
        
        
        if (data.action_time !== undefined) updatePayload.action_time = data.action_time;
        
        
        if (data.details !== undefined) updatePayload.details = data.details;
        
        
        updatePayload.updatedById = currentUser.id;

        await audit_log.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await audit_log.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return audit_log;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_log = await db.audit_log.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of audit_log) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of audit_log) {
                await record.destroy({transaction});
            }
        });


        return audit_log;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const audit_log = await db.audit_log.findByPk(id, options);

        await audit_log.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await audit_log.destroy({
            transaction
        });

        return audit_log;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const audit_log = await db.audit_log.findOne(
            { where },
            { transaction },
        );

        if (!audit_log) {
            return audit_log;
        }

        const output = audit_log.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await audit_log.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.action) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_log',
                        'action',
                        filter.action,
                    ),
                };
            }
            
            if (filter.entity) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_log',
                        'entity',
                        filter.entity,
                    ),
                };
            }
            
            if (filter.entity_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_log',
                        'entity_ref',
                        filter.entity_ref,
                    ),
                };
            }
            
            if (filter.details) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_log',
                        'details',
                        filter.details,
                    ),
                };
            }
            

            
            

            
            if (filter.action_timeRange) {
                const [start, end] = filter.action_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    action_time: {
                    ...where.action_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    action_time: {
                    ...where.action_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.audit_log.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'audit_log',
                        'action',
                        query,
                    ),
                ],
            };
        }

        const records = await db.audit_log.findAll({
            attributes: [ 'id', 'action' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['action', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.action,
        }));
    }

    
};

